Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision caf5d608169807a028a2cd63e1c2eb8962eaa347)
+++ src/boundary.cpp	(revision e4ea462e4975fcf1debaf5bbf7e4ced6f9d55b4d)
@@ -1116,96 +1461,215 @@
   dif_b.SubtractVector(&(Candidate->x));
   AngleCheck.CopyVector(&dif_a);
+  AngleCheck.Scale(-1);
   AngleCheck.ProjectOntoPlane(Chord);
 
-  if (problem)
-  {
-	  cout << "Atom number" << Candidate->nr << endl;
-	  Candidate->x.Output((ofstream *)&cout);
-	  cout << "number of bonds " << mol->NumberOfBondsPerAtom[Candidate->nr] << endl;
-  }
+  SideA = dif_b.Norm();
+  SideB = dif_a.Norm();
+  SideC = Chord->Norm();
+  //Chord->Scale(-1);
+
+  alpha = Chord->Angle(&dif_a);
+  beta = M_PI - Chord->Angle(&dif_b);
+  gamma = dif_a.Angle(&dif_b);
+
+
+  if (DEBUG)
+    {
+      cout << "Atom number" << Candidate->nr << endl;
+      Candidate->x.Output((ofstream *) &cout);
+      cout << "number of bonds " << mol->NumberOfBondsPerAtom[Candidate->nr]
+          << endl;
+    }
 
   if (a != Candidate and b != Candidate)
-  {
-
-	  if (Chord->Norm()/(2*sin(0.5*dif_a.Angle(&dif_b)))<RADIUS) //Using Formula for relation of chord length with inner angle to find if Ball will touch atom
-	  {
-		  if (dif_a.ScalarProduct(d1)/fabs(dif_a.ScalarProduct(d1))>Storage[0]) //This will give absolute preference to those in "right-hand" quadrants
-		  {
-			  Opt_Candidate = Candidate;
-			  Storage[0]=dif_a.ScalarProduct(d1)/fabs(dif_a.ScalarProduct(d1));
-			  Storage[1]=AngleCheck.Angle(OldNormal);
-		  }
-		  else
-		  {
-			  if ((dif_a.ScalarProduct(d1)/fabs(dif_a.ScalarProduct(d1)) == Storage[0] && Storage[0]>0 &&  Storage[1]> AngleCheck.Angle(OldNormal)) or \
-					  (dif_a.ScalarProduct(d1)/fabs(dif_a.ScalarProduct(d1)) == Storage[0] && Storage[0]<0 &&  Storage[1]< AngleCheck.Angle(OldNormal)))
-				  //Depending on quadrant we prefer higher or lower atom with respect to Triangle normal first.
-			  {
-				  Opt_Candidate = Candidate;
-				  Storage[0]=dif_a.ScalarProduct(d1)/fabs(dif_a.ScalarProduct(d1));
-				  Storage[1]=AngleCheck.Angle(OldNormal);
-			  }
-			  else
-			  {
-				  if (problem)
-					  cout << "Looses to better candidate" << endl;
-			  }
-		  }
-	  }
-	  else
-	  {
-		  if (problem)
-			  cout << "erfuellt Dreiecksbedingung fuer sehne nicht" <<endl;
-	  }
-  }
+    {
+//      alpha = dif_a.Angle(&dif_b) / 2.;
+//      SideA = Chord->Norm() / 2.;// (Chord->Norm()/2.) / sin(0.5*alpha);
+//      SideB = dif_a.Norm();
+//      centerline = SideA * SideA + SideB * SideB - 2. * SideA * SideB * cos(
+//          alpha); // note this is squared of center line length
+// Those are remains from Freddie. Needed?
+
+//      centerline = (Chord->Norm()/2.) / sin(0.5*alpha);
+//      Old Chordtest. Replaced by test for Radius of Circumscribing circle
+
+      Umkreisradius = SideA / 2.0 / sin(alpha);
+      cout << Umkreisradius << endl;
+      cout << SideB / 2.0 / sin(beta) << endl;
+      cout << SideC / 2.0 / sin(gamma) << endl;
+
+      if (Umkreisradius < RADIUS)
+        {
+
+          sign = AngleCheck.ScalarProduct(d1);
+          sign /= fabs(sign); // +1 if in direction of triangle plane, -1 if in other direction...
+
+          // intermediate calculations:
+
+          Umkreismittelpunkt = (a->x) * sin(2.*alpha) + b->x * sin(2.*beta) + (Candidate->x) * sin(2.*gamma) ;
+          Umkreismittelpunkt.Scale(1/(sin(2*alpha) + sin(2*beta) + sin(2*gamma)));
+
+          cout << "Umkreismittelpunkt has coordinates" << Umkreismittelpunkt.x[0] << " "<< Umkreismittelpunkt.x[1] <<" "<<Umkreismittelpunkt.x[2] << endl;
+          cout << "Candidate has coordinates" << Candidate->x.x[0]<< " " << Candidate->x.x[1] << " " << Candidate->x.x[2] << endl;
+          cout << "a has coordinates" << a->x.x[0]<< " " << a->x.x[1] << " " << a->x.x[2] << endl;
+          cout << "b has coordinates" << b->x.x[0]<< " " << b->x.x[1] << " " << b->x.x[2] << endl;
+
+          TempNormal.CopyVector(&dif_a);
+          TempNormal.VectorProduct(&dif_b);
+          if (TempNormal.ScalarProduct(OldNormal)<0 && sign>0 || TempNormal.ScalarProduct(OldNormal)>0 && sign<0)
+            {
+              TempNormal.Scale(-1);
+            }
+          TempNormal.Normalize();
+          Restradius = sqrt(RADIUS*RADIUS - Umkreisradius*Umkreisradius);
+          cout << "Umkreisradius ist " << Umkreisradius << endl;
+          cout << "Restradius ist " << Restradius << endl;
+          TempNormal.Scale(Restradius);
+          cout << "TempNormal has coordinates " << TempNormal.x[0] << " " << TempNormal.x[1] << " " << TempNormal.x[2] << " " << endl;
+          Mittelpunkt.CopyVector(&Umkreismittelpunkt);
+          Mittelpunkt.AddVector(&TempNormal);  //this is center of sphere supported by a, b and Candidate
+          cout << "Mittelpunkt has coordinates" << Mittelpunkt.x[0] << " " << Mittelpunkt.x[1]<< " "  <<Mittelpunkt.x[2] << endl;
+          cout << "Dist a to UmkreisMittelpunkt " << a->x.Distance(&Umkreismittelpunkt) << endl;
+          cout << "Dist b to UmkreisMittelpunkt " << b->x.Distance(&Umkreismittelpunkt) << endl;
+          cout << "Dist Candidate to UmkreisMittelpunkt " << Candidate->x.Distance(&Umkreismittelpunkt) << endl;
+          cout << "Dist a to Mittelpunkt " << a->x.Distance(&Mittelpunkt) << endl;
+          cout << "Dist b to Mittelpunkt " << b->x.Distance(&Mittelpunkt) << endl;
+          cout << "Dist Candidate to Mittelpunkt " << Candidate->x.Distance(&Mittelpunkt) << endl;
+
+          if (Storage[0]< -1.5) // first Candidate at all
+            {
+
+              cout << "Next better candidate is " << *Candidate << " with ";
+              Opt_Candidate = Candidate;
+              Storage[0] = sign;
+              Storage[1] = AngleCheck.Angle(OldNormal);
+              Opt_Mittelpunkt->CopyVector(&Mittelpunkt);
+              cout << "Angle is " << Storage[1] << ", Halbraum ist "
+                  << Storage[0] << endl;
+            }
+          else
+            {
+              //We will now check for non interference, that is if the new candidate would have the Opt_Candidate
+              //within the ball.
+
+              Distance = Opt_Candidate->x.Distance(&Mittelpunkt);
+              cout << "Opt_Candidate " << Opt_Candidate << " has distance " << Distance << " to Center of Candidate " << endl;
+
+
+              if (Distance >RADIUS) // We have no interference and may now check whether the new point is better.
+                {
+                  cout << "Atom " << Candidate << " has distance " << Candidate->x.Distance(Opt_Mittelpunkt) << " to Center of Candidate " << endl;
+
+                  if ((Storage[0] < 0 && fabs(sign - Storage[0]) > CurrentEpsilon))// || //This will give absolute preference to those in "right-hand" quadrants
+                      //sqrt(Candidate->x.Distance(Opt_Mittelpunkt)) < RADIUS)    //and those where Candidate would be within old Sphere.
+                    {
+                      cout << "Next better candidate is " << *Candidate << " with ";
+                      Opt_Candidate = Candidate;
+                      Storage[0] = sign;
+                      Storage[1] = AngleCheck.Angle(OldNormal);
+                      Opt_Mittelpunkt->CopyVector(&Mittelpunkt);
+                      cout << "Angle is " << Storage[1] << ", Halbraum ist "
+                          << Storage[0] << endl;
+                    }
+                  else
+                    {
+                      if ((fabs(sign - Storage[0]) < CurrentEpsilon && sign > 0
+                          && Storage[1] > AngleCheck.Angle(OldNormal)) ||
+                          (fabs(sign - Storage[0]) < CurrentEpsilon && sign < 0
+                          && Storage[1] < AngleCheck.Angle(OldNormal)))
+                      //Depending on quadrant we prefer higher or lower atom with respect to Triangle normal first.
+                        {
+                          cout << "Next better candidate is " << *Candidate << " with ";
+                          Opt_Candidate = Candidate;
+                          Storage[0] = sign;
+                          Storage[1] = AngleCheck.Angle(OldNormal);
+                          Opt_Mittelpunkt->CopyVector(&Mittelpunkt);
+                          cout << "Angle is " << Storage[1] << ", Halbraum ist "
+                              << Storage[0] << endl;
+                        }
+                    }
+                }
+              else
+                {
+                  if (DEBUG)
+                    cout << "Looses to better candidate" << endl;
+                }
+            }
+        }
+      else
+        {
+          if (DEBUG)
+            {
+              cout << "Doesn't satisfy requirements for circumscribing circle" << endl;
+            }
+        }
+    }
+
   else
-  {
-	  if (problem)
-	  		  cout << "identisch mit Ursprungslinie" << endl;
-  }
-
-  if (n<5) // Five is the recursion level threshold.
-  {
-	  for(int i=0; i<mol->NumberOfBondsPerAtom[Candidate->nr];i++) // go through all bond
-      {
-		  Walker = mol->ListOfBondsPerAtom[Candidate->nr][i]->GetOtherAtom(Candidate);
-		  if (Walker->nr == Parent->nr){
-			  continue;
-		  }
-		  else{
-			  Find_next_suitable_point(a, b, Walker, Candidate, n+1, Chord, d1, OldNormal, Opt_Candidate, Storage, RADIUS, mol, problem);  //call function again
-		  }
-      }
-  }
-};
-
-/*!
- * this function fins a triangle to a line, adjacent to an existing one.
+    {
+      if (DEBUG)
+        cout << "identisch mit Ursprungslinie" << endl;
+    }
+
+  if (RecursionLevel < 7) // Five is the recursion level threshold.
+    {
+      for (int i = 0; i < mol->NumberOfBondsPerAtom[Candidate->nr]; i++) // go through all bond
+        {
+          Walker = mol->ListOfBondsPerAtom[Candidate->nr][i]->GetOtherAtom(
+              Candidate);
+          if (Walker == Parent)
+            { // don't go back the same bond
+              continue;
+            }
+          else
+            {
+              Find_next_suitable_point(a, b, Walker, Candidate, RecursionLevel
+                  + 1, Chord, d1, OldNormal, Opt_Candidate, Opt_Mittelpunkt, Storage, RADIUS,
+                  mol); //call function again
+            }
+        }
+    }
+}
+;
+
+/** This function finds a triangle to a line, adjacent to an existing one.
+ * @param out   output stream for debugging
+ * @param tecplot output stream for writing found triangles in TecPlot format
+ * @param mol molecule structure with all atoms and bonds
+ * @param Line current baseline to search from
+ * @param T current triangle which \a Line is edge of
+ * @param RADIUS radius of the rolling ball
+ * @param N number of found triangles
  */
-void Tesselation::Find_next_suitable_triangle(ofstream *out, ofstream *tecplot, molecule* mol, BoundaryLineSet &Line, BoundaryTriangleSet &T, const double& RADIUS, int N)
-{
-	cout << Verbose(1) << "Looking for next suitable triangle \n";
+void
+Tesselation::Find_next_suitable_triangle(ofstream *out, ofstream *tecplot,
+    molecule* mol, BoundaryLineSet &Line, BoundaryTriangleSet &T,
+    const double& RADIUS, int N)
+{
+  cout << Verbose(1) << "Looking for next suitable triangle \n";
   Vector direction1;
   Vector helper;
   Vector Chord;
+  ofstream *tempstream = NULL;
+  char filename[255];
   //atom* Walker;
 
   double Storage[2];
-  Storage[0]=-2.;    // This direction is either +1 or -1 one, so any result will take precedence over initial values
-  Storage[1]=9999999.;  // This is also lower then any value produced by an eligible atom, which are all positive
+  Storage[0] = -2.; // This direction is either +1 or -1 one, so any result will take precedence over initial values
+  Storage[1] = 9999999.; // This is also lower then any value produced by an eligible atom, which are all positive
   atom* Opt_Candidate = NULL;
-
+  Vector Opt_Mittelpunkt;
 
   cout << Verbose(1) << "Constructing helpful vectors ... " << endl;
   helper.CopyVector(&(Line.endpoints[0]->node->x));
-  for (int i =0; i<3; i++)
-    {
-      if (T.endpoints[i]->node->nr != Line.endpoints[0]->node->nr && T.endpoints[i]->node->nr!=Line.endpoints[1]->node->nr)
-	{
-	  helper.SubtractVector(&T.endpoints[i]->node->x);
-	  break;
-	}
-    }
-
+  for (int i = 0; i < 3; i++)
+    {
+      if (T.endpoints[i]->node->nr != Line.endpoints[0]->node->nr
+          && T.endpoints[i]->node->nr != Line.endpoints[1]->node->nr)
+        {
+          helper.SubtractVector(&T.endpoints[i]->node->x);
+          break;
+        }
+    }
 
   direction1.CopyVector(&Line.endpoints[0]->node->x);
@@ -1213,5 +1677,5 @@
   direction1.VectorProduct(&(T.NormalVector));
 
-  if (direction1.ScalarProduct(&helper)<0)
+  if (direction1.ScalarProduct(&helper) < 0)
     {
       direction1.Scale(-1);
@@ -1221,19 +1685,39 @@
   Chord.SubtractVector(&(Line.endpoints[1]->node->x));
 
-  cout << Verbose(1) << "Looking for third point candidates for triangle ... " << endl;
-  Find_next_suitable_point(Line.endpoints[0]->node, Line.endpoints[1]->node, Line.endpoints[0]->node, Line.endpoints[1]->node, 0, &Chord, &direction1, &(T.NormalVector), Opt_Candidate, Storage, RADIUS, mol,0);
-  Find_next_suitable_point(Line.endpoints[0]->node, Line.endpoints[1]->node, Line.endpoints[1]->node, Line.endpoints[0]->node, 0, &Chord, &direction1, &(T.NormalVector), Opt_Candidate, Storage, RADIUS, mol,0);
-
-  if (N>7)
-  {
-	  cout << Verbose(1) << "No new Atom found, triangle construction will crash" << endl;
-	  write_tecplot_file(out, tecplot, this, mol);
-	  tecplot->flush();
-	  Find_next_suitable_point(Line.endpoints[0]->node, Line.endpoints[1]->node, Line.endpoints[0]->node, Line.endpoints[1]->node, 0, &Chord, &direction1, &(T.NormalVector), Opt_Candidate, Storage, RADIUS, mol, 1);
-	  Find_next_suitable_point(Line.endpoints[0]->node, Line.endpoints[1]->node, Line.endpoints[1]->node, Line.endpoints[0]->node, 0, &Chord, &direction1, &(T.NormalVector), Opt_Candidate, Storage, RADIUS, mol, 1);
+  cout << Verbose(1) << "Looking for third point candidates for triangle ... "
+      << endl;
+  Find_next_suitable_point(Line.endpoints[0]->node, Line.endpoints[1]->node,
+      Line.endpoints[0]->node, Line.endpoints[1]->node, 0, &Chord, &direction1,
+      &(T.NormalVector), Opt_Candidate, &Opt_Mittelpunkt, Storage, RADIUS, mol);
+  Find_next_suitable_point(Line.endpoints[0]->node, Line.endpoints[1]->node,
+      Line.endpoints[1]->node, Line.endpoints[0]->node, 0, &Chord, &direction1,
+      &(T.NormalVector), Opt_Candidate, &Opt_Mittelpunkt, Storage, RADIUS, mol);
+
+  if ((TrianglesOnBoundaryCount % 10) == 0)
+    {
+    sprintf(filename, "testEnvelope-%d.dat", TriangleFilesWritten);
+    tempstream = new ofstream(filename, ios::trunc);
+    write_tecplot_file(out, tempstream, this, mol, TriangleFilesWritten++);
+    tempstream->close();
+    tempstream->flush();
+    delete(tempstream);
   }
+
+  if ((Opt_Candidate == NULL) || (N<12))
+    {
+      cout << Verbose(1)
+          << "No new Atom found, triangle construction will crash" << endl;
+      write_tecplot_file(out, tecplot, this, mol, TriangleFilesWritten);
+      Find_next_suitable_point(Line.endpoints[0]->node,
+          Line.endpoints[1]->node, Line.endpoints[0]->node,
+          Line.endpoints[1]->node, 0, &Chord, &direction1, &(T.NormalVector),
+          Opt_Candidate, &Opt_Mittelpunkt, Storage, RADIUS, mol);
+      Find_next_suitable_point(Line.endpoints[0]->node,
+          Line.endpoints[1]->node, Line.endpoints[1]->node,
+          Line.endpoints[0]->node, 0, &Chord, &direction1, &(T.NormalVector),
+          Opt_Candidate, &Opt_Mittelpunkt, Storage, RADIUS, mol);
+    }
   // Konstruiere nun neues Dreieck am Ende der Liste der Dreiecke
 
-  cout << Verbose(1) << "Adding exactly one Walker for reasons completely unknown to me ... " << endl;
   cout << " Optimal candidate is " << *Opt_Candidate << endl;
 
@@ -1241,212 +1725,229 @@
   AddTrianglePoint(Line.endpoints[0]->node, 1);
   AddTrianglePoint(Line.endpoints[1]->node, 2);
-  
-  BPS[0] = TPS[0];
-  BPS[1] = TPS[1];
-  AddTriangleLine(0);
-  BPS[0] = TPS[0];
-  BPS[1] = TPS[2];
-  AddTriangleLine(1);
-  BPS[0] = TPS[1];
-  BPS[1] = TPS[2];
-  AddTriangleLine(2);
+
+  AddTriangleLine(TPS[0], TPS[1], 0);
+  AddTriangleLine(TPS[0], TPS[2], 1);
+  AddTriangleLine(TPS[1], TPS[2], 2);
 
   BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
   AddTriangleToLines();
-  
-  
-  cout << Verbose(1) << "Constructing normal vector for this triangle ... " << endl;
+  cout << "New triangle with " << *BTS << endl;
+
+  cout << Verbose(1) << "Constructing normal vector for this triangle ... "
+      << endl;
 
   BTS->GetNormalVector(BTS->NormalVector);
 
-  if ((BTS->NormalVector.ScalarProduct(&(T.NormalVector))<0 && Storage[0]>0) ||
-		  ((BTS->NormalVector.ScalarProduct(&(T.NormalVector))>0 && Storage[0]<0)) )
+  if ((BTS->NormalVector.ScalarProduct(&(T.NormalVector)) < 0 && Storage[0] > 0)
+      || ((BTS->NormalVector.ScalarProduct(&(T.NormalVector)) > 0 && Storage[0]
+          < 0)))
     {
       BTS->NormalVector.Scale(-1);
     };
 
-};
-
-
-void Find_second_point_for_Tesselation(atom* a, atom* Candidate, atom* Parent, int n, Vector Oben, atom*& Opt_Candidate, double Storage[2], molecule* mol, double RADIUS)
-{
-	cout << Verbose(1) << "Looking for second point of starting triangle, recursive level "<< n <<endl;;
-	int i;
-	Vector AngleCheck;
-	atom* Walker;
-
-	if (a->nr !=Candidate->nr)
-	{
-		AngleCheck.CopyVector(&(Candidate->x));
-		AngleCheck.SubtractVector(&(a->x));
-		if (AngleCheck.Norm() < RADIUS and AngleCheck.Angle(&Oben) < Storage[0])
-		{
-			//cout << Verbose(1) << "Old values of Storage: %lf %lf \n", Storage[0], Storage[1]);
-			Opt_Candidate=Candidate;
-			Storage[0]=AngleCheck.Angle(&Oben);
-			//cout << Verbose(1) << "Changing something in Storage: %lf %lf. \n", Storage[0], Storage[1]);
-		}
-		else{
-			if (AngleCheck.Norm() > RADIUS)
-			{
-				cout << Verbose(1) << "refused due to Radius" << AngleCheck.Norm() << endl;
-			}
-			else{
-				cout << Verbose(1) << "Supposedly looses to a better candidate" << Opt_Candidate->nr << endl;
-			}
-		}
-	}
-
-	if (n<5)
-    {
-      for (i = 0; i< mol->NumberOfBondsPerAtom[Candidate->nr]; i++)
-      {
-    	  Walker = mol->ListOfBondsPerAtom[Candidate->nr][i]->GetOtherAtom(Candidate);
-    	  if (Walker->nr == Parent->nr)
-    		  continue;
-    	  else
-    		  Find_second_point_for_Tesselation(a, Walker, Candidate, n+1, Oben, Opt_Candidate, Storage, mol, RADIUS);
-      };
+}
+;
+
+void
+Find_second_point_for_Tesselation(atom* a, atom* Candidate, atom* Parent,
+    int RecursionLevel, Vector Oben, atom*& Opt_Candidate, double Storage[2],
+    molecule* mol, double RADIUS)
+{
+  cout << Verbose(1)
+      << "Looking for second point of starting triangle, recursive level "
+      << RecursionLevel << endl;;
+  int i;
+  Vector AngleCheck;
+  atom* Walker;
+  double norm = -1.;
+
+  // check if we only have one unique point yet ...
+  if (a != Candidate)
+    {
+      AngleCheck.CopyVector(&(Candidate->x));
+      AngleCheck.SubtractVector(&(a->x));
+      norm = AngleCheck.Norm();
+      // second point shall have smallest angle with respect to Oben vector
+      if (norm < RADIUS)
+        {
+          if (AngleCheck.Angle(&Oben) < Storage[0])
+            {
+              //cout << Verbose(1) << "Old values of Storage: %lf %lf \n", Storage[0], Storage[1]);
+              cout << "Next better candidate is " << *Candidate
+                  << " with distance " << norm << ".\n";
+              Opt_Candidate = Candidate;
+              Storage[0] = AngleCheck.Angle(&Oben);
+              //cout << Verbose(1) << "Changing something in Storage: %lf %lf. \n", Storage[0], Storage[1]);
+            }
+          else
+            {
+              cout << Verbose(1) << "Supposedly looses to a better candidate "
+                  << *Opt_Candidate << endl;
+            }
+        }
+      else
+        {
+          cout << Verbose(1) << *Candidate << " refused due to Radius " << norm
+              << endl;
+        }
+    }
+
+  // if not recursed to deeply, look at all its bonds
+  if (RecursionLevel < 7)
+    {
+      for (i = 0; i < mol->NumberOfBondsPerAtom[Candidate->nr]; i++)
+        {
+          Walker = mol->ListOfBondsPerAtom[Candidate->nr][i]->GetOtherAtom(
+              Candidate);
+          if (Walker == Parent) // don't go back along the bond we came from
+            continue;
+          else
+            Find_second_point_for_Tesselation(a, Walker, Candidate,
+                RecursionLevel + 1, Oben, Opt_Candidate, Storage, mol, RADIUS);
+        };
     };
-
-
-};
-
-
-void Tesselation::Find_starting_triangle(molecule* mol, const double RADIUS)
-{
-	cout << Verbose(1) << "Looking for starting triangle \n";
-  int i=0;
+}
+;
+
+void
+Tesselation::Find_starting_triangle(molecule* mol, const double RADIUS)
+{
+  cout << Verbose(1) << "Looking for starting triangle \n";
+  int i = 0;
   atom* Walker;
   atom* FirstPoint;
   atom* SecondPoint;
-  int max_index[3];
+  atom* max_index[3];
   double max_coordinate[3];
   Vector Oben;
   Vector helper;
   Vector Chord;
+  Vector Opt_Mittelpunkt;
 
   Oben.Zero();
 
-
-  for(i =0; i<3; i++)
-    {
-      max_index[i] =-1;
-      max_coordinate[i] =-1;
-    }
-cout << Verbose(1) << "Molecule mol is there and has " << mol->AtomCount << " Atoms \n";
+  for (i = 0; i < 3; i++)
+    {
+      max_index[i] = NULL;
+      max_coordinate[i] = -1;
+    }
+  cout << Verbose(1) << "Molecule mol is there and has " << mol->AtomCount
+      << " Atoms \n";
+
+  // 1. searching topmost atom with respect to each axis
   Walker = mol->start;
   while (Walker->next != mol->end)
     {
-    	Walker = Walker->next;
-    	for (i=0; i<3; i++)
-    	{
-    		if (Walker->x.x[i] > max_coordinate[i])
-    		{
-    			max_coordinate[i]=Walker->x.x[i];
-    			max_index[i]=Walker->nr;
-    		}
-    	}
-    }
-
-  cout << Verbose(1) << "Found maximum coordinates. "<< endl;
+      Walker = Walker->next;
+      for (i = 0; i < 3; i++)
+        {
+          if (Walker->x.x[i] > max_coordinate[i])
+            {
+              max_coordinate[i] = Walker->x.x[i];
+              max_index[i] = Walker;
+            }
+        }
+    }
+
+  cout << Verbose(1) << "Found maximum coordinates. " << endl;
   //Koennen dies fuer alle Richtungen, legen hier erstmal Richtung auf k=0
-  const int k=0;
-
-  Oben.x[k]=1.;
-  FirstPoint = mol->start;
-  FirstPoint = FirstPoint->next;
-  while (FirstPoint->nr != max_index[k])
-    {
-	  FirstPoint = FirstPoint->next;
-    }
-  cout << Verbose(1) << "Coordinates of start atom: " << FirstPoint->x.x[0] << endl;
+  const int k = 1;
+  Oben.x[k] = 1.;
+  FirstPoint = max_index[k];
+
+  cout << Verbose(1) << "Coordinates of start atom " << *FirstPoint << ": "
+      << FirstPoint->x.x[0] << endl;
   double Storage[2];
   atom* Opt_Candidate = NULL;
-  Storage[0]=999999.;   // This will contain the angle, which will be always positive (when looking for second point), when looking for third point this will be the quadrant.
-  Storage[1]=999999.;  // This will be an angle looking for the third point.
-  cout << Verbose(1) << "Number of Bonds: " << mol->NumberOfBondsPerAtom[FirstPoint->nr] << endl;
-
-  Find_second_point_for_Tesselation(FirstPoint, mol->ListOfBondsPerAtom[FirstPoint->nr][0]->GetOtherAtom(FirstPoint), FirstPoint, 0, Oben, Opt_Candidate, Storage, mol, RADIUS);
-
-
+  Storage[0] = 999999.; // This will contain the angle, which will be always positive (when looking for second point), when looking for third point this will be the quadrant.
+  Storage[1] = 999999.; // This will be an angle looking for the third point.
+  cout << Verbose(1) << "Number of Bonds: "
+      << mol->NumberOfBondsPerAtom[FirstPoint->nr] << endl;
+
+  Find_second_point_for_Tesselation(FirstPoint, FirstPoint, FirstPoint, 0,
+      Oben, Opt_Candidate, Storage, mol, RADIUS); // we give same point as next candidate as its bonds are looked into in find_second_...
   SecondPoint = Opt_Candidate;
-  Opt_Candidate=NULL;
+  cout << Verbose(1) << "Found second point is " << *SecondPoint << ".\n";
+
   helper.CopyVector(&(FirstPoint->x));
   helper.SubtractVector(&(SecondPoint->x));
+  helper.Normalize();
   Oben.ProjectOntoPlane(&helper);
+  Oben.Normalize();
   helper.VectorProduct(&Oben);
-  Storage[0]=-2.;   	// This will indicate the quadrant.
-  Storage[1]= 9999999.; // This will be an angle looking for the third point.
+  Storage[0] = -2.; // This will indicate the quadrant.
+  Storage[1] = 9999999.; // This will be an angle looking for the third point.
 
   Chord.CopyVector(&(FirstPoint->x)); // bring into calling function
   Chord.SubtractVector(&(SecondPoint->x));
+  // Now, oben and helper are two orthonormalized vectors in the plane defined by Chord (not normalized)
 
   cout << Verbose(1) << "Looking for third point candidates \n";
-  Find_next_suitable_point(FirstPoint, SecondPoint, SecondPoint, FirstPoint, 0, &Chord, &helper, &Oben, Opt_Candidate, Storage, RADIUS, mol, 0);
-
-
-  //Starting Triangle is Walker, SecondPoint, Opt_Candidate
-
-    cout << Verbose(1) << "The found starting triangle consists of " << *FirstPoint << ", " << *SecondPoint << " and " << *Opt_Candidate << "." << endl;
-
+  // look in one direction of baseline for initial candidate
+  Opt_Candidate = NULL;
+  Opt_Mittelpunkt;
+  Find_next_suitable_point(FirstPoint, SecondPoint, SecondPoint, FirstPoint, 0,
+      &Chord, &helper, &Oben, Opt_Candidate, &Opt_Mittelpunkt, Storage, RADIUS, mol);
+  // look in other direction of baseline for possible better candidate
+  Find_next_suitable_point(FirstPoint, SecondPoint, FirstPoint, SecondPoint, 0,
+      &Chord, &helper, &Oben, Opt_Candidate, &Opt_Mittelpunkt, Storage, RADIUS, mol);
+  cout << Verbose(1) << "Third Point is " << *Opt_Candidate << endl;
+
+  // FOUND Starting Triangle: FirstPoint, SecondPoint, Opt_Candidate
+
+  cout << Verbose(1) << "The found starting triangle consists of "
+      << *FirstPoint << ", " << *SecondPoint << " and " << *Opt_Candidate
+      << "." << endl;
+
+  // Finally, we only have to add the found points
   AddTrianglePoint(FirstPoint, 0);
   AddTrianglePoint(SecondPoint, 1);
   AddTrianglePoint(Opt_Candidate, 2);
-  
-  BPS[0] = TPS[0];
-  BPS[1] = TPS[1];
-  BLS[0] = new class BoundaryLineSet(BPS , LinesOnBoundaryCount);
-  BPS[0] = TPS[1];
-  BPS[1] = TPS[2];
-  BLS[1] = new class BoundaryLineSet(BPS , LinesOnBoundaryCount);
-  BPS[0] = TPS[0];
-  BPS[1] = TPS[2];
-  BLS[2] = new class BoundaryLineSet(BPS , LinesOnBoundaryCount);
-
-  Tesselation::BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
-  TrianglesOnBoundary.insert( TrianglePair(TrianglesOnBoundaryCount, BTS) );
-  TrianglesOnBoundaryCount++;
-
-  for(int i=0;i<NDIM;i++)
-    {
-      LinesOnBoundary.insert( LinePair(LinesOnBoundaryCount, BTS->lines[i]) );
-      LinesOnBoundaryCount++;
-    };
-
-       BTS->GetNormalVector(BTS->NormalVector);
-
-       if( BTS->NormalVector.ScalarProduct(&Oben)<0)
-	 {
-	   BTS->NormalVector.Scale(-1);
-	 }
-};
-
-
-void Find_non_convex_border(ofstream *out, ofstream *tecplot, molecule* mol)
-{
-	int N =0;
-	struct Tesselation *Tess = new Tesselation;
-	cout << Verbose(1) << "Entering search for non convex hull. " << endl;
-	cout << flush;
-	const double RADIUS =6.;
-	LineMap::iterator baseline;
-	Tess->Find_starting_triangle(mol, RADIUS);
-
-	baseline = Tess->LinesOnBoundary.begin();
-	while (baseline != Tess->LinesOnBoundary.end()) {
-		if (baseline->second->TrianglesCount == 1)
-		{
-			cout << Verbose(1) << "Begin of Tesselation ... " << endl;
-			Tess->Find_next_suitable_triangle(out, tecplot, mol, *(baseline->second), *(baseline->second->triangles.begin()->second), RADIUS, N); //the line is there, so there is a triangle, but only one.
-			cout << Verbose(1) << "End of Tesselation ... " << endl;
-		}
-		else
-		{
-			cout << Verbose(1) << "There is a line with " << baseline->second->TrianglesCount << " triangles adjacent";
-		}
-		N++;
-		baseline++;
-	}
-
-};
+  // ... and respective lines
+  AddTriangleLine(TPS[0], TPS[1], 0);
+  AddTriangleLine(TPS[1], TPS[2], 1);
+  AddTriangleLine(TPS[0], TPS[2], 2);
+  // ... and triangles to the Maps of the Tesselation class
+  BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
+  AddTriangleToLines();
+  // ... and calculate its normal vector (with correct orientation)
+  Oben.Scale(-1.);
+  BTS->GetNormalVector(Oben);
+}
+;
+
+void
+Find_non_convex_border(ofstream *out, ofstream *tecplot, molecule* mol)
+{
+  int N = 0;
+  struct Tesselation *Tess = new Tesselation;
+  cout << Verbose(1) << "Entering search for non convex hull. " << endl;
+  cout << flush;
+  const double RADIUS = 6.;
+  LineMap::iterator baseline;
+  Tess->Find_starting_triangle(mol, RADIUS);
+
+  baseline = Tess->LinesOnBoundary.begin();
+  while (baseline != Tess->LinesOnBoundary.end())
+    {
+      if (baseline->second->TrianglesCount == 1)
+        {
+          cout << Verbose(1) << "Begin of Tesselation ... " << endl;
+          Tess->Find_next_suitable_triangle(out, tecplot, mol,
+              *(baseline->second),
+              *(((baseline->second->triangles.begin()))->second), RADIUS, N); //the line is there, so there is a triangle, but only one.
+          cout << Verbose(1) << "End of Tesselation ... " << endl;
+        }
+      else
+        {
+          cout << Verbose(1) << "There is a line with "
+              << baseline->second->TrianglesCount << " triangles adjacent"
+              << endl;
+        }
+      N++;
+      baseline++;
+    }
+  write_tecplot_file(out, tecplot, Tess, mol, -1);
+
+}
+;
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision caf5d608169807a028a2cd63e1c2eb8962eaa347)
+++ src/boundary.hpp	(revision e4ea462e4975fcf1debaf5bbf7e4ced6f9d55b4d)
@@ -83,5 +83,5 @@
     void AddPoint(atom * Walker);
     void AddTrianglePoint(atom* Candidate, int n);
-    void AddTriangleLine(int n);
+    void AddTriangleLine(class BoundaryPointSet *a, class BoundaryPointSet *b, int n);
     void AddTriangleToLines();
     void Find_starting_triangle(molecule* mol, const double RADIUS);
@@ -91,5 +91,5 @@
     LineMap LinesOnBoundary;
     TriangleMap TrianglesOnBoundary;
-    class BoundaryPointSet *TPS[3]; //this is a Storage for pointers to triangle points, this and BPS[2] needed due to AddLine restrictions 
+    class BoundaryPointSet *TPS[3]; //this is a Storage for pointers to triangle points, this and BPS[2] needed due to AddLine restrictions
     class BoundaryPointSet *BPS[2];
     class BoundaryLineSet *BLS[3];
@@ -98,4 +98,5 @@
     int LinesOnBoundaryCount;
     int TrianglesOnBoundaryCount;
+    int TriangleFilesWritten;
 };
 
Index: src/vector.cpp
===================================================================
--- src/vector.cpp	(revision caf5d608169807a028a2cd63e1c2eb8962eaa347)
+++ src/vector.cpp	(revision e4ea462e4975fcf1debaf5bbf7e4ced6f9d55b4d)
@@ -22,7 +22,19 @@
 Vector::~Vector() {};
 
+/** Calculates square of distance between this and another vector.
+ * \param *y array to second vector
+ * \return \f$| x - y |^2\f$
+ */
+double Vector::DistanceSquared(const Vector *y) const
+{
+  double res = 0.;
+  for (int i=NDIM;i--;)
+    res += (x[i]-y->x[i])*(x[i]-y->x[i]);
+  return (res);
+};
+
 /** Calculates distance between this and another vector.
  * \param *y array to second vector
- * \return \f$| x - y |^2\f$
+ * \return \f$| x - y |\f$
  */
 double Vector::Distance(const Vector *y) const
@@ -31,5 +43,5 @@
   for (int i=NDIM;i--;)
     res += (x[i]-y->x[i])*(x[i]-y->x[i]);
-  return (res);
+  return (sqrt(res));
 };
 
